import StateEstimationNoisyNN
from StateEstimationNoisyNN import *
reload(StateEstimationNoisyNN)

##########################################################################
###
###      Examples
###     
##########################################################################

# Tuple of tuples, indexed first by actual then by observed, gives
# P(observed | actual) Be lazy and use the integer color indices:
# white, black, r, g, blue

noisySensorModel = ((0.8, 0.05, 0.05, 0.05, 0.05),
              (0.05, 0.8, 0.05, 0.05, 0.05),
              (0.05, 0.05, 0.8, 0.05, 0.05),
              (0.05, 0.05, 0.05, 0.8, 0.05),
              (0.05, 0.05, 0.05, 0.05, 0.8))

perfectSensorModel = ((1.0, 0.0, 0.0, 0.0, 0.0),
                      (0.0, 1.0, 0.0, 0.0, 0.0),
                      (0.0, 0.0, 1.0, 0.0, 0.0),
                      (0.0, 0.0, 0.0, 1.0, 0.0),
                      (0.0, 0.0, 0.0, 0.0, 1.0))


# Transition model.  Given a state (robot pose, in this case) and an
# action, return a distribution over next states P(newState | state,
# action).  Returns a list of next-states that have non-zero
# probability, together with their probability.
# With prob (1 - noiseProb) the robot goes where intended;  the rest
# of the probabability mass is evenly divided among the neighboring
# states. 
# Action can be any desired x-y (0, 1), (0, -1), (1, 0), (-1, 0), (0, 0)
def noisyMotionModel((rx, ry), (ax, ay), xmax, ymax):
    def cx(a): return clip(a, 0, xmax-1)
    def cy(a): return clip(a, 0, ymax-1)
    noiseProb = 0.2
    p = noiseProb/8.0
    return (((cx(rx+ax),cy(ry+ay)), 1 - noiseProb),
            ((cx(rx+ax+1),cy(ry+ay+1)), p), 
            ((cx(rx+ax+1),cy(ry+ay)), p),
            ((cx(rx+ax+1),cy(ry+ay-1)), p),
            ((cx(rx+ax),cy(ry+ay+1)), p),
            ((cx(rx+ax),cy(ry+ay-1)), p),
            ((cx(rx+ax-1),cy(ry+ay+1)), p),
            ((cx(rx+ax-1),cy(ry+ay)), p),
            ((cx(rx+ax-1),cy(ry+ay-1)), p))

def perfectMotionModel((rx, ry), (ax, ay), xmax, ymax):
    def cx(a): return clip(a, 0, xmax-1)
    def cy(a): return clip(a, 0, ymax-1)
    return (((cx(rx+ax),cy(ry+ay)), 1.0),)

#w55 = World(5, 5, (), (), ((0,0),),((4,4),), (3, 3), \
#            noisySensorModel, noisyMotionModel)

#w51nn = World(5, 1, (), (), ((2,0),), (), (0,0), noisySensorModel, noisyMotionModel)

#w51na = World(5, 1, (), (), ((2,0),), (), (0,0), perfectSensorModel, noisyMotionModel)

#w51ns = World(5, 1, (), (), ((2,0),), (), (0,0), noisySensorModel, perfectMotionModel)

#w201pp = World(20, 1, (), (), ((8,0),(9,0),(10,0),(11,0),(12,0)), (), (0,0), perfectSensorModel, perfectMotionModel)

w51pp = World(5, 1, (), (), ((2,0),), (), (0,0), perfectSensorModel, perfectMotionModel) 
